--- groff-1.18.orig/font/devX75/DESC
+++ groff-1.18/font/devX75/DESC
@@ -1,5 +1,6 @@
 styles R I B BI
-fonts 6 0 0 0 0 0 S
+fonts 8 0 0 0 0 0 S M G
+ondemand M G
 sizes 8 10 12 14 18 24 0
 res 75
 X11
--- groff-1.18.orig/font/devX75/Makefile.sub
+++ groff-1.18/font/devX75/Makefile.sub
@@ -1,2 +1,13 @@
 DEV=X75
-DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S
+DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S M G
+CLEANADD=M G
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' M > G
--- groff-1.18.orig/font/devX75/M.header
+++ groff-1.18/font/devX75/M.header
@@ -0,0 +1,3 @@
+name M
+spacewidth 11
+fixedkanji 11,9,2 0
--- groff-1.18.orig/font/devX75-12/DESC
+++ groff-1.18/font/devX75-12/DESC
@@ -1,5 +1,6 @@
 styles R I B BI
-fonts 6 0 0 0 0 0 S
+fonts 8 0 0 0 0 0 S M G
+ondemand M G
 sizes 8 10 12 14 18 24 0
 res 75
 X11
--- groff-1.18.orig/font/devX75-12/Makefile.sub
+++ groff-1.18/font/devX75-12/Makefile.sub
@@ -1,2 +1,13 @@
 DEV=X75-12
-DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S
+DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S M G
+CLEANADD=M G
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' M > G
--- groff-1.18.orig/font/devX75-12/M.header
+++ groff-1.18/font/devX75-12/M.header
@@ -0,0 +1,3 @@
+name M
+spacewidth 11
+fixedkanji 11,9,2 0
--- groff-1.18.orig/font/devX100/DESC
+++ groff-1.18/font/devX100/DESC
@@ -1,5 +1,6 @@
 styles R I B BI
-fonts 6 0 0 0 0 0 S
+fonts 8 0 0 0 0 0 S M G
+ondemand M G
 sizes 8 10 12 14 18 24 0
 res 100
 X11
--- groff-1.18.orig/font/devX100/Makefile.sub
+++ groff-1.18/font/devX100/Makefile.sub
@@ -1,2 +1,13 @@
 DEV=X100
-DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S
+DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S M G
+CLEANADD=M G
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' M > G
--- groff-1.18.orig/font/devX100/M.header
+++ groff-1.18/font/devX100/M.header
@@ -0,0 +1,3 @@
+name M
+spacewidth 16
+fixedkanji 16,14,2 0
--- groff-1.18.orig/font/devX100-12/DESC
+++ groff-1.18/font/devX100-12/DESC
@@ -1,5 +1,6 @@
 styles R I B BI
-fonts 6 0 0 0 0 0 S
+fonts 8 0 0 0 0 0 S M G
+ondemand M G
 sizes 8 10 12 14 18 24 0
 res 100
 X11
--- groff-1.18.orig/font/devX100-12/Makefile.sub
+++ groff-1.18/font/devX100-12/Makefile.sub
@@ -1,2 +1,14 @@
 DEV=X100-12
-DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S
+DEVFILES=DESC TR TI TB TBI CR CI CB CBI HR HI HB HBI NR NI NB NBI S M G
+CLEANADD=M G
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' M > G
+
--- groff-1.18.orig/font/devX100-12/M.header
+++ groff-1.18/font/devX100-12/M.header
@@ -0,0 +1,3 @@
+name M
+spacewidth 16
+fixedkanji 16,14,2 0
--- groff-1.18.orig/font/devhtml/Makefile.sub
+++ groff-1.18/font/devhtml/Makefile.sub
@@ -1,8 +1,8 @@
 DEV=html
 PROTOFONTS=R I B BI CR
 FONTS=$(PROTOFONTS) S
-DEVFILES=$(FONTS) DESC
-CLEANADD=$(FONTS) DESC
+DEVFILES=$(FONTS) DESC M G
+CLEANADD=$(FONTS) DESC M G
 
 RES=240
 CPI=10
@@ -32,3 +32,12 @@
 	    -e "s/^fonts .*$$/fonts `set $(FONTS); echo $$#` $(FONTS)/" \
 	    $(srcdir)/DESC.proto >$@
 
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' M > G
--- groff-1.18.orig/font/devhtml/M.header
+++ groff-1.18/font/devhtml/M.header
@@ -0,0 +1,3 @@
+name M
+spacewidth 16
+fixedkanji 16,14,2 0
--- groff-1.18.orig/font/devlj4/Makefile.sub
+++ groff-1.18/font/devlj4/Makefile.sub
@@ -22,9 +22,9 @@
 	echo "unitwidth `expr 7620000 / $(LJ4RES)`" >>DESC
 	cat $(srcdir)/DESC.in >>DESC
 	if test "$(PAGE)" = A4; then \
-	  echo "papersize a4" >>DESC; \
+	  echo "papersize /etc/papersize a4" >>DESC; \
 	else \
-	  echo "papersize letter" >>DESC; \
+	  echo "papersize /etc/papersize letter" >>DESC; \
 	fi
 	test -z '$(LJ4PRINT)' || echo print '$(LJ4PRINT)' >>DESC
 
--- groff-1.18.orig/font/devlbp/Makefile.sub
+++ groff-1.18/font/devlbp/Makefile.sub
@@ -13,9 +13,9 @@
 	-rm -f DESC
 	cat $(srcdir)/DESC.in >>DESC
 	if test "$(PAGE)" = A4; then \
-	  echo "papersize a4" >>DESC; \
+	  echo "papersize /etc/papersize a4" >>DESC; \
 	else \
-	  echo "papersize letter" >>DESC; \
+	  echo "papersize /etc/papersize letter" >>DESC; \
 	fi
 	test -z '$(LBPPRINT)' || echo print '$(LBPPRINT)' >>DESC
 
--- groff-1.18.orig/font/devascii8/DESC.proto
+++ groff-1.18/font/devascii8/DESC.proto
@@ -0,0 +1,8 @@
+res 240
+hor 24
+vert 40
+unitwidth 10
+sizes 10 0
+fonts 4 R I B BI
+tcommand
+postpro grotty
--- groff-1.18.orig/font/devascii8/Makefile.sub
+++ groff-1.18/font/devascii8/Makefile.sub
@@ -0,0 +1,31 @@
+DEV=ascii8
+FONTS=R I B BI
+DEVFILES=$(FONTS) DESC
+CLEANADD=$(FONTS) DESC
+
+RES=240
+CPI=10
+LPI=6
+
+$(FONTS): R.proto
+	@echo Making $@
+	@-rm -f $@
+	@(charwidth=`expr $(RES) / $(CPI)` ; \
+ 	 sed -e "s/^name [A-Z]*$$/name $@/" \
+	     -e "s/^\\([^	]*\\)	[0-9]+	/\\1	$$charwidth	/" \
+	     -e "s/^spacewidth [0-9]+$$/spacewidth $$charwidth/" \
+	     -e "s/^internalname .*$$/internalname $@/" \
+	     -e "/^internalname/s/BI/3/" \
+	     -e "/^internalname/s/B/2/" \
+	     -e "/^internalname/s/I/1/" \
+	     -e "/^internalname .*[^ 0-9]/d" \
+	     $(srcdir)/R.proto >$@)
+
+DESC: DESC.proto
+	@echo Making $@
+	@-rm -f $@
+	@sed -e "s/^res .*$$/res $(RES)/" \
+	    -e "s/^hor .*$$/hor `expr $(RES) / $(CPI)`/" \
+	    -e "s/^vert .*$$/vert `expr $(RES) / $(LPI)`/" \
+	    -e "s/^fonts .*$$/fonts `set $(FONTS); echo $$#` $(FONTS)/" \
+	    $(srcdir)/DESC.proto >$@
--- groff-1.18.orig/font/devascii8/R.proto
+++ groff-1.18/font/devascii8/R.proto
@@ -0,0 +1,262 @@
+name R
+internalname 0
+spacewidth 24
+charset
+!	24	0	0041
+"	24	0	0042
+dq	"
+lq	"
+rq	"
+#	24	0	0043
+sh	"
+$	24	0	0044
+Do	"
+%	24	0	0045
+&	24	0	0046
+'	24	0	0047
+aa	"
+fm	"
+aq	"
+cq	"
+(	24	0	0050
+)	24	0	0051
+*	24	0	0052
+**	"
++	24	0	0053
+pl	"
+,	24	0	0054
+\-	24	0	0055
+hy	"
+-	"
+mi	"
+en	"
+.	24	0	0056
+/	24	0	0057
+sl	"
+f/	"
+0	24	0	0060
+1	24	0	0061
+2	24	0	0062
+3	24	0	0063
+4	24	0	0064
+5	24	0	0065
+6	24	0	0066
+7	24	0	0067
+8	24	0	0070
+9	24	0	0071
+:	24	0	0072
+;	24	0	0073
+<	24	0	0074
+la	"
+fo	"
+=	24	0	0075
+eq	"
+>	24	0	0076
+ra	"
+fc	"
+?	24	0	0077
+@	24	0	0100
+at	"
+A	24	0	0101
+*A	"
+B	24	0	0102
+*B	"
+C	24	0	0103
+D	24	0	0104
+E	24	0	0105
+*E	"
+F	24	0	0106
+G	24	0	0107
+H	24	0	0110
+*Y	"
+I	24	0	0111
+*I	"
+J	24	0	0112
+K	24	0	0113
+*K	"
+L	24	0	0114
+M	24	0	0115
+*M	"
+N	24	0	0116
+*N	"
+O	24	0	0117
+ci	"
+*O	"
+P	24	0	0120
+*R	"
+Q	24	0	0121
+R	24	0	0122
+S	24	0	0123
+T	24	0	0124
+*T	"
+U	24	0	0125
+V	24	0	0126
+W	24	0	0127
+X	24	0	0130
+*X	"
+Y	24	0	0131
+*U	"
+Z	24	0	0132
+*Z	"
+[	24	0	0133
+lB	"
+\	24	0	0134
+rs	"
+]	24	0	0135
+rB	"
+a^	24	0	0136
+^	"
+ha	"
+_	24	0	0137
+ru	"
+ul	"
+`	24	0	0140
+oq	"
+ga	"
+a	24	0	0141
+b	24	0	0142
+c	24	0	0143
+d	24	0	0144
+e	24	0	0145
+f	24	0	0146
+g	24	0	0147
+h	24	0	0150
+i	24	0	0151
+.i	"
+j	24	0	0152
+k	24	0	0153
+l	24	0	0154
+m	24	0	0155
+n	24	0	0156
+o	24	0	0157
+*o	"
+p	24	0	0160
+q	24	0	0161
+r	24	0	0162
+s	24	0	0163
+t	24	0	0164
+u	24	0	0165
+v	24	0	0166
+w	24	0	0167
+x	24	0	0170
+mu	"
+y	24	0	0171
+z	24	0	0172
+lC	24	0	0173
+{	"
+ba	24	0	0174
+or	"
+bv	"
+br	"
+|	"
+lb	"
+lc	"
+lf	"
+lk	"
+lt	"
+rb	"
+rc	"
+rf	"
+rk	"
+rt	"
+rC	24	0	0175
+}	"
+a~	24	0	0176
+~	"
+ap	"
+ti	"
+char161	24	0	0241
+char162	24	0	0242
+char163	24	0	0243
+char164	24	0	0244
+char165	24	0	0245
+char166	24	0	0246
+char167	24	0	0247
+char168	24	0	0250
+char169	24	0	0251
+char170	24	0	0252
+char171	24	0	0253
+char172	24	0	0254
+char173	24	0	0255 
+char174	24	0	0256
+char175	24	0	0257
+char176	24	0	0260
+char177	24	0	0261
+char178	24	0	0262
+char179	24	0	0263
+char180	24	0	0264
+char181	24	0	0265
+char182	24	0	0266
+char183	24	0	0267
+char184	24	0	0270
+char185	24	0	0271
+char186	24	0	0272
+char187	24	0	0273
+char188	24	0	0274
+char189	24	0	0275
+char190	24	0	0276
+char191	24	0	0277
+char192	24	0	0300
+char193	24	0	0301
+char194	24	0	0302
+char195	24	0	0303
+char196	24	0	0304
+char197	24	0	0305
+char198	24	0	0306
+char199	24	0	0307
+char200	24	0	0310
+char201	24	0	0311
+char202	24	0	0312
+char203	24	0	0313
+char204	24	0	0314
+char205	24	0	0315
+char206	24	0	0316
+char207	24	0	0317
+char208	24	0	0320
+char209	24	0	0321
+char210	24	0	0322
+char211	24	0	0323
+char212	24	0	0324
+char213	24	0	0325
+char214	24	0	0326
+char215	24	0	0327
+char216	24	0	0330
+char217	24	0	0331
+char218	24	0	0332
+char219	24	0	0333
+char220	24	0	0334
+char221	24	0	0335
+char222	24	0	0336
+char223	24	0	0337
+char224	24	0	0340
+char225	24	0	0341
+char226	24	0	0342
+char227	24	0	0343
+char228	24	0	0344
+char229	24	0	0345
+char230	24	0	0346
+char231	24	0	0347
+char232	24	0	0350
+char233	24	0	0351
+char234	24	0	0352
+char235	24	0	0353
+char236	24	0	0354
+char237	24	0	0355
+char238	24	0	0356
+char239	24	0	0357
+char240	24	0	0360
+char241	24	0	0361
+char242	24	0	0362
+char243	24	0	0363
+char244	24	0	0364
+char245	24	0	0365
+char246	24	0	0366
+char247	24	0	0367
+char248	24	0	0370
+char249	24	0	0371
+char250	24	0	0372
+char251	24	0	0373
+char252	24	0	0374
+char253	24	0	0375
+char254	24	0	0376
+char255	24	0	0377
--- groff-1.18.orig/font/devnippon/DESC.proto
+++ groff-1.18/font/devnippon/DESC.proto
@@ -0,0 +1,9 @@
+res 240
+hor 24
+vert 40
+unitwidth 10
+sizes 10 0
+fonts 6 R I B BI M G
+ondemand M G
+tcommand
+postpro grotty
--- groff-1.18.orig/font/devnippon/M.header
+++ groff-1.18/font/devnippon/M.header
@@ -0,0 +1,4 @@
+name M
+internalname 4
+spacewidth 48
+fixedkanji 48 0
--- groff-1.18.orig/font/devnippon/Makefile.sub
+++ groff-1.18/font/devnippon/Makefile.sub
@@ -0,0 +1,44 @@
+DEV=nippon
+FONTS=R I B BI
+WFONTS=M G
+ALLFONTS=$(FONTS) $(WFONTS)
+DEVFILES=$(ALLFONTS) DESC
+CLEANADD=$(ALLFONTS) DESC M G
+
+RES=240
+CPI=10
+LPI=6
+
+$(FONTS): R.proto
+	@echo Making $@
+	@-rm -f $@
+	@(charwidth=`expr $(RES) / $(CPI)` ; \
+ 	 sed -e "s/^name [A-Z]*$$/name $@/" \
+	     -e "s/^\\([^	]*\\)	[0-9]+	/\\1	$$charwidth	/" \
+	     -e "s/^spacewidth [0-9]+$$/spacewidth $$charwidth/" \
+	     -e "s/^internalname .*$$/internalname $@/" \
+	     -e "/^internalname/s/BI/3/" \
+	     -e "/^internalname/s/B/2/" \
+	     -e "/^internalname/s/I/1/" \
+	     -e "/^internalname .*[^ 0-9]/d" \
+	     $(srcdir)/R.proto >$@)
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' \
+	    -e 's/internalname 4/internalname 5/' M > G
+		
+DESC: DESC.proto
+	@echo Making $@
+	@-rm -f $@
+	@sed -e "s/^res .*$$/res $(RES)/" \
+	    -e "s/^hor .*$$/hor `expr $(RES) / $(CPI)`/" \
+	    -e "s/^vert .*$$/vert `expr $(RES) / $(LPI)`/" \
+	    -e "s/^fonts .*$$/fonts `set $(ALLFONTS); echo $$#` $(ALLFONTS)/" \
+	    $(srcdir)/DESC.proto >$@
--- groff-1.18.orig/font/devnippon/R.proto
+++ groff-1.18/font/devnippon/R.proto
@@ -0,0 +1,167 @@
+name R
+internalname 0
+spacewidth 24
+charset
+!	24	0	0041
+"	24	0	0042
+dq	"
+lq	"
+rq	"
+#	24	0	0043
+sh	"
+$	24	0	0044
+Do	"
+%	24	0	0045
+&	24	0	0046
+'	24	0	0047
+aa	"
+fm	"
+aq	"
+cq	"
+(	24	0	0050
+)	24	0	0051
+*	24	0	0052
+**	"
++	24	0	0053
+pl	"
+,	24	0	0054
+\-	24	0	0055
+hy	"
+-	"
+mi	"
+en	"
+.	24	0	0056
+/	24	0	0057
+sl	"
+f/	"
+0	24	0	0060
+1	24	0	0061
+2	24	0	0062
+3	24	0	0063
+4	24	0	0064
+5	24	0	0065
+6	24	0	0066
+7	24	0	0067
+8	24	0	0070
+9	24	0	0071
+:	24	0	0072
+;	24	0	0073
+<	24	0	0074
+la	"
+fo	"
+=	24	0	0075
+eq	"
+>	24	0	0076
+ra	"
+fc	"
+?	24	0	0077
+@	24	0	0100
+at	"
+A	24	0	0101
+*A	"
+B	24	0	0102
+*B	"
+C	24	0	0103
+D	24	0	0104
+E	24	0	0105
+*E	"
+F	24	0	0106
+G	24	0	0107
+H	24	0	0110
+*Y	"
+I	24	0	0111
+*I	"
+J	24	0	0112
+K	24	0	0113
+*K	"
+L	24	0	0114
+M	24	0	0115
+*M	"
+N	24	0	0116
+*N	"
+O	24	0	0117
+ci	"
+*O	"
+P	24	0	0120
+*R	"
+Q	24	0	0121
+R	24	0	0122
+S	24	0	0123
+T	24	0	0124
+*T	"
+U	24	0	0125
+V	24	0	0126
+W	24	0	0127
+X	24	0	0130
+*X	"
+Y	24	0	0131
+*U	"
+Z	24	0	0132
+*Z	"
+[	24	0	0133
+lB	"
+\	24	0	0134
+rs	"
+]	24	0	0135
+rB	"
+a^	24	0	0136
+^	"
+ha	"
+_	24	0	0137
+ru	"
+ul	"
+`	24	0	0140
+oq	"
+ga	"
+a	24	0	0141
+b	24	0	0142
+c	24	0	0143
+d	24	0	0144
+e	24	0	0145
+f	24	0	0146
+g	24	0	0147
+h	24	0	0150
+i	24	0	0151
+.i	"
+j	24	0	0152
+k	24	0	0153
+l	24	0	0154
+m	24	0	0155
+n	24	0	0156
+o	24	0	0157
+*o	"
+p	24	0	0160
+q	24	0	0161
+r	24	0	0162
+s	24	0	0163
+t	24	0	0164
+u	24	0	0165
+v	24	0	0166
+w	24	0	0167
+x	24	0	0170
+mu	"
+y	24	0	0171
+z	24	0	0172
+lC	24	0	0173
+{	"
+ba	24	0	0174
+or	"
+bv	"
+br	"
+|	"
+lb	"
+lc	"
+lf	"
+lk	"
+lt	"
+rb	"
+rc	"
+rf	"
+rk	"
+rt	"
+rC	24	0	0175
+}	"
+a~	24	0	0176
+~	"
+ap	"
+ti	"
--- groff-1.18.orig/font/devnippon/createM.pl
+++ groff-1.18/font/devnippon/createM.pl
@@ -0,0 +1,55 @@
+#!/usr/bin/perl
+# cat <header> | ./$0 -{jis|euc} <metric> <type>
+#
+
+$jis=0;
+if ($ARGV[0] =~ /-jis/) {
+  $jis = 1;
+} elsif ($ARGV[0] =~ /-euc/) {
+  $jis = 0;
+} else {
+  print STDERR "$0: -jis or -euc\n"; exit 1;
+}
+$metric=$ARGV[1];
+$type=$ARGV[2];
+
+while (<STDIN>) {
+    print;	
+}
+print "charset\n";
+$WCTABLE_SIZE = 94;
+$WCTABLE_OFFSET = 0xa1;
+
+LOOP: for ($ku = 0; $ku < $WCTABLE_SIZE; $ku++) {
+    for ($ten = 0; $ten < $WCTABLE_SIZE; $ten++) {
+	$wc = (($ku + $WCTABLE_OFFSET) << 8) & 0xff00;
+	$wc |= ($ten + $WCTABLE_OFFSET) & 0xff;
+	if ($wc >= 0xa2af && $wc <= 0xa2b9 ||
+	    $wc >= 0xa2c2 && $wc <= 0xa2c9 ||
+	    $wc >= 0xa2d1 && $wc <= 0xa2db ||
+	    $wc >= 0xa2eb && $wc <= 0xa2f1 ||
+	    $wc >= 0xa2fa && $wc <= 0xa2fd ||
+	    $wc >= 0xa3a1 && $wc <= 0xa3af ||
+	    $wc >= 0xa3ba && $wc <= 0xa3c0 ||
+	    $wc >= 0xa3db && $wc <= 0xa3e0 ||
+	    $wc >= 0xa3fb && $wc <= 0xa3fe ||
+	    $wc >= 0xa4f4 && $wc <= 0xa4fe ||
+	    $wc >= 0xa5f7 && $wc <= 0xa5fe ||
+	    $wc >= 0xa6b9 && $wc <= 0xa6c0 ||
+	    $wc >= 0xa6d9 && $wc <= 0xa6fe ||
+	    $wc >= 0xa7c2 && $wc <= 0xa7d0 ||
+	    $wc >= 0xa7f2 && $wc <= 0xa7fe ||
+	    $wc >= 0xa8c1 && $wc <= 0xaffe ||
+	    $wc >= 0xcfd4 && $wc <= 0xcffe) {
+	    next;
+	} elsif ($wc >= 0xf4a5) {
+	    last LOOP;
+	} else {
+	    printf("%c%c\t%s\t%s\t%#x\n",
+		   $ku + $WCTABLE_OFFSET, $ten + $WCTABLE_OFFSET,
+		   $metric, $type, 
+		   ($jis ? ($wc & 0x7f7f) : $wc));
+	}
+    }
+}
+exit 0;
--- groff-1.18.orig/tmac/Makefile.sub
+++ groff-1.18/tmac/Makefile.sub
@@ -25,15 +25,18 @@
   html.tmac www.tmac \
   eqnrc \
   troffrc troffrc-end \
-  hyphen.us
+  hyphen.us \
+  andocj.tmac \
+  euc-jp.tmac
 SPECIALFILES=an.tmac man.tmac s.tmac ms.tmac
-STRIPFILES=e.tmac doc.tmac doc-old.tmac
-MDOCFILES=doc-common doc-ditroff doc-nroff doc-syms
+STRIPFILES=e.tmac doc.tmac doc-old.tmac docj.tmac
+MDOCFILES=doc-common doc-ditroff doc-nroff doc-syms docj-ditroff docj-nroff
 mdocdir=$(tmacdir)/mdoc
 CLEANADD=\
   stamp-wrap stamp-sed *-wrap man.tmac-sed ms.tmac-sed \
   stamp-strip e.tmac-s doc.tmac-s doc-old.tmac-s \
-  doc-common-s doc-ditroff-s doc-nroff-s doc-syms-s mdoc.local-s
+  doc-common-s doc-ditroff-s doc-nroff-s doc-syms-s mdoc.local-s \
+  docj.tmac-s docj-ditroff-s docj-nroff-s
 tmac_s_prefix=
 tmac_an_prefix=
 tmac_wrap=
--- groff-1.18.orig/tmac/troffrc
+++ groff-1.18/tmac/troffrc
@@ -13,7 +13,9 @@
 .do ds troffrc!X100 X.tmac
 .do ds troffrc!X100-12 X.tmac
 .do ds troffrc!ascii tty.tmac
+.do ds troffrc!ascii8 tty.tmac
 .do ds troffrc!latin1 tty.tmac
+.do ds troffrc!nippon tty.tmac
 .do ds troffrc!utf8 tty.tmac
 .do ds troffrc!cp1047 tty.tmac
 .do ds troffrc!lj4 lj4.tmac
@@ -37,3 +39,6 @@
 .do hpf hyphen.us
 .
 .\" Don't let blank lines creep in here.
+.\"
+.\" for Japanese hack
+.if "\V[LANG]"ja_JP.eucJP" .do mso euc-jp.tmac
--- groff-1.18.orig/tmac/andocj.tmac
+++ groff-1.18/tmac/andocj.tmac
@@ -0,0 +1,12 @@
+.\" Load either tmac.an or tmac.doc.
+.if !\n(.g .ab These macros require groff.
+.de Dd
+.rm Dd
+.do mso tmac.docj
+\\*(Dd\\
+..
+.de TH
+.rm TH
+.do mso tmac.an
+\\*(TH\\
+..
--- groff-1.18.orig/tmac/docj-ditroff
+++ groff-1.18/tmac/docj-ditroff
@@ -0,0 +1,305 @@
+.\" Copyright (c) 1991 The Regents of the University of California.
+.\" All rights reserved.
+.\"
+.\" Redistribution and use in source and binary forms, with or without
+.\" modification, are permitted provided that the following conditions
+.\" are met:
+.\" 1. Redistributions of source code must retain the above copyright
+.\"    notice, this list of conditions and the following disclaimer.
+.\" 2. Redistributions in binary form must reproduce the above copyright
+.\"    notice, this list of conditions and the following disclaimer in the
+.\"    documentation and/or other materials provided with the distribution.
+.\" 3. All advertising materials mentioning features or use of this software
+.\"    must display the following acknowledgement:
+.\"	This product includes software developed by the University of
+.\"	California, Berkeley and its contributors.
+.\" 4. Neither the name of the University nor the names of its contributors
+.\"    may be used to endorse or promote products derived from this software
+.\"    without specific prior written permission.
+.\"
+.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+.\" SUCH DAMAGE.
+.\"
+.\"     @(#)doc-ditroff	5.8 (Berkeley) 8/5/91
+.\"
+.\" tmac.mdoc-ditroff
+.if \n(.g .if !rC .nr C 0
+.ds aD \fI\s10
+.ds aR \f(CO\s10
+.ds cM \f(CB\s10
+.ds dF \fR\s10
+.ds eM \fI\s10
+.ds eR \fC\s10
+.ds eV \fC\s10
+.ds fA \f(CO\s10
+.ds fD \f(CB\s10
+.ds fL \f(CB\s10
+.ds fN \f(CB\s10
+.ds fP \fP\s0
+.ds fS \s0
+.ds fT \f(CO\s10
+.ds Hs \fR\s10
+.ds iC \f(CB\s10
+.ds lI \fC
+.ds lP \fR\|(\|\fP\s10
+.ds lp \fR(\fP\s10
+.ds rP \fR\|)\|\fP\s10
+.ds rp \fR)\fP\s10
+.ds lB \fR\^[\^\fP\s10
+.ds rB \fR\^]\fP\s10
+.ds mL \fB\s10
+.ds nM \f(CB\s10
+.ds nO \fR\s10
+.ds nT \s0
+.ds pA \fC\s10
+.ds Pu \fR{\ .\ ,\ :\ ;\ (\ )\ [\ ]\ \fR}
+.ds rA \fR\s10
+.ds rT \f(CO\s10
+.ds sH \fB\s10
+.ds sP \s0
+.ds sY \fB\s10
+.ds sX \fR\s10
+.ds tF \fR
+.ds tN \s9
+.ds vA \fI\s10
+.ds Vs \fR\s10
+.ds vT \f(CB\s10
+.ds xR \fC\s10
+.tr *\(**
+.nr sI \w\fC,u*5
+.nr Ti \n(sIu
+.nr Pp .5v
+.ds lS \0
+.nr lS \w'\0'u
+.nr dI 6n
+.de pL
+.nr Hm .5i
+.nr Fm .5i
+.nr ll 6.5i
+.ll 6.5i
+.nr lt 6.5i
+.lt 6.5i
+.nr po 1i
+.po 1.i
+.nr dV .5v
+..
+.ds <= \(<=
+.ds >= \(>=
+.ie \n(.g \{\
+.	ds Lq \(lq
+.	ds Rq \(rq
+.\}
+.el \{\
+.	ds Lq \&``
+.	ds Rq \&''
+.\}
+.ds ua \(ua
+.ds aa \(aa
+.ds ga \(ga
+.ds sR \&'
+.ds sL \&`
+.ds q \&"
+.ds Pi \(*p
+.ds Ne \(!=
+.ds Le \(<=
+.ds Ge \(>=
+.ds Lt <
+.ds Gt >
+.ds Pm \(+-
+.ds If \(if
+.ds Na \fINaN\fP
+.ds Ba \fR\&|\fP
+.nr gX 0
+.de hK
+.ds hT \\*(dT
+.if !"\\*(cH"Null" \{\
+.       ie !"\\*(gP"Null" .as hT \|(\|\\*(cH\\*(gP\|)
+.       el .as hT \\|(\\|\\*(cH\\|)
+.\}
+.if "\\*(cH"Null" \{\
+.	if !"\\*(gP"Null" .as hT \&\|(\|\\*(gP\|)
+.\}
+.wh 0 hM
+.wh -1.25i fM
+.nr nL \\n(nl
+.ie \\n(gX==1 \{\
+.	rm n1
+.	bp
+.\}
+.el \{\
+'	bp
+.\}
+.if \\n(nL>0 \{\
+.	if !\\nC \{\
+.		nr % 1
+.	\}
+.\}
+.nr gX 0
+.em lM
+..
+.nr fW \w\fC0
+.de sW
+.nr sW \w\fC\\$1
+.ie \\n(sW>=\\n(fW \{\
+.       ie \\n(sW%\\n(fW .nr sW (\\n(sW/\\n(fW)+1
+.       el .nr sW \\n(sW/\\n(fW
+.\}
+.el \{\
+.	ie \\n(sW>0 .nr sW 1
+.	el .nr sW 0
+.\}
+..
+.de aW
+.nr sW \w\fC\\*(A\\$1
+.ie \\n(sW>=\\n(fW \{\
+.       ie \\n(sW%\\n(fW .nr sW (\\n(sW/\\n(fW)+1
+.       el .nr sW \\n(sW/\\n(fW
+.\}
+.el \{\
+.	ie \\n(sW>0 .nr sW 1
+.	el .nr sW 0
+.\}
+..
+.de Ql
+.if \\n(aC==0  \{\
+.	ds mN Ql
+.       ds A1 \\$1
+.       ds A2 \\$2
+.       ds A3 \\$3
+.       ds A4 \\$4
+.       ds A5 \\$5
+.       ds A6 \\$6
+.       ds A7 \\$7
+.       ds A8 \\$8
+. 	nr fV \\n(.$
+. 	fV
+.\}
+.nr aP \\n(aP+1
+.aW \\n(aP
+.nr aP \\n(aP-1
+.if \\n(sW>2 .Li
+.if \\n(sW<=2 \{\
+.	if (\\n(aP>0) \{\
+.		ds A\\n(aP Li
+.		nr aP \\n(aP -1
+.	\}		
+.	if (\\n(aP==0) \{\
+.		rm C0 C1 C2 C3 C4 C5 C6 C7 C8 C9
+.		rm S1 S2 S3 S4 S5 S6 S7 S8 S9
+.		rn A8 A9
+.		rn A7 A8
+.		rn A6 A7
+.		rn A5 A6
+.		rn A4 A5
+.		rn A3 A4
+.		rn A2 A3
+.		rn A1 A2
+.		ds A1 Li
+.	 	nr fV \\n(aC+1
+.		nr aC 0
+.		fV
+.	\}
+.	ds qL \&\\*(sL
+.	ds qR \&\\*(sR
+.	En
+.\}
+..
+.de Sh
+.nr nS 0
+.nr sE 0
+.nr iS 0
+'ad
+.ie "\\$1"NAME" \{\
+.       hK
+'       in 0
+.\}
+.el \{\
+.	ie "\\$1"Ì¾Á°" \{\
+.      		hK
+'		in 0
+.	\}
+.	el \{\
+.		ie "\\$1"Ì¾¾Î" \{\
+.       		hK
+'       		in 0
+.		\}
+.		el \{\
+.       		nr nS 0
+.       		nr nA 0
+.			nr nF 0
+.       		nr nT 0
+.       		nr nY 0
+.       		nr oT 0
+.       		if "\\$1"SYNOPSIS" \{\
+.				na
+.				nr nS 1
+.			\}
+.       		if "\\$1"½ñ¼°" \{\
+.				na
+.				nr nS 1
+.			\}
+.       		if "\\$1"DESCRIPTION" \{\
+.				nr fY 0
+.				nr fZ 0
+.				nr fB 0
+.				nr Fb 0
+.				ds Fb
+.			\}
+.       		if "\\$1"ÀâÌÀ" \{\
+.				nr fY 0
+.				nr fZ 0
+.				nr fB 0
+.				nr Fb 0
+.				ds Fb
+.			\}
+.       		if "\\$1"²òÀâ" \{\
+.				nr fY 0
+.				nr fZ 0
+.				nr fB 0
+.				nr Fb 0
+.				ds Fb
+.			\}
+.       		if "\\$1"SEE" \{\
+.               		nr nA 1
+.               		na
+.       		\}
+.       		if "\\$1"´ØÏ¢¹àÌÜ" \{\
+.               		nr nA 1
+.               		na
+.       		\}
+.       		if "\\$1"FILES" .nr nF 1
+.       		if "\\$1"¥Õ¥¡¥¤¥ë" .nr nF 1
+.       		if "\\$1"´ØÏ¢¥Õ¥¡¥¤¥ë" .nr nF 1
+.       		if "\\$1"STANDARDS" .nr nT 1
+.       		if "\\$1"½àµò" .nr nT 1
+.       		if "\\$1"µ¬³Ê" .nr nT 1
+.       		if "\\$1"AUTHORS" .nr nY 1
+.       		if "\\$1"Ãø¼Ô" .nr nY 1
+.       		if "\\$1"ºî¼Ô" .nr nY 1
+.			if "\\$1"SEE" .nr sE 1
+.			if "\\$1"´ØÏ¢¹àÌÜ" .nr sE 1
+.       		in 0
+.       		nr aN 0
+.		\}
+.	\}
+.\}
+.pL
+'sp
+.ns
+.ta .5i 1i 1.5i 2i 2.5i 3i 3.5i 4i 4.5i 5i 5.5i 6i 6.5i
+.if !\\n(cR .ne 3
+'fi
+\&\\*(sH\\$1 \|\\$2 \|\\$3 \|\\$4 \|\\$5 \|\\$6 \|\\$7 \|\\$8 \|\\$9
+\&\fP\s0\&
+.in \\n(.iu+\\n(Tiu
+.ns
+..
--- groff-1.18.orig/tmac/docj-nroff
+++ groff-1.18/tmac/docj-nroff
@@ -0,0 +1,247 @@
+.\" Copyright (c) 1991 The Regents of the University of California.
+.\" All rights reserved.
+.\"
+.\" Redistribution and use in source and binary forms, with or without
+.\" modification, are permitted provided that the following conditions
+.\" are met:
+.\" 1. Redistributions of source code must retain the above copyright
+.\"    notice, this list of conditions and the following disclaimer.
+.\" 2. Redistributions in binary form must reproduce the above copyright
+.\"    notice, this list of conditions and the following disclaimer in the
+.\"    documentation and/or other materials provided with the distribution.
+.\" 3. All advertising materials mentioning features or use of this software
+.\"    must display the following acknowledgement:
+.\"	This product includes software developed by the University of
+.\"	California, Berkeley and its contributors.
+.\" 4. Neither the name of the University nor the names of its contributors
+.\"    may be used to endorse or promote products derived from this software
+.\"    without specific prior written permission.
+.\"
+.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+.\" SUCH DAMAGE.
+.\"
+.\"     @(#)doc-nroff	5.6 (Berkeley) 8/5/91
+.\"
+.\" tmac.mdoc-nroff
+.ds aD \fI
+.ds aR \fI
+.ds cM \fB
+.ds dF \fR
+.ds eM \fI
+.ds eR \fR
+.ds eV \fR
+.ds fA \fI
+.ds fD \fB
+.ds fL \fB
+.ds fN \fB
+.ds fP \fP
+.ds fS
+.ds fT \fI
+.ds Hs \fR
+.ds iC \fB
+.ds lI \fR
+.ds lP \fR\|(\fP
+.ds rP \fR\|)\fP
+.ds lp \fR\|(\fP
+.ds rp \fR\|)\fP
+.ds lB \fR\|[\|\fP
+.ds rB \fR\|]\fP
+.ds mL \fB
+.ds nM \fB
+.ds nO \fR
+.ds pA \fI
+.ds Pu {\ .\ ,\ ;\ :\ (\ )\ [\ ]}
+.ds rA \fR
+.ds rT \fI
+.ds sH \fB
+.ds sP
+.ds sY \fB
+.ds sX \fI
+.ds tF \fR
+.ds tN
+.ds vA \fI
+.ds Vs \fR
+.ds vT \fB
+.ds xR \fR
+.nr sI .5i
+.nr Ti .5i
+.nr cR 1
+.nr Pp 1v
+.ds lS \0\0
+.nr lS \w'\0\0'u
+.nr dI 6n
+.de pL
+.ie \\n(cR .nr Hm 0
+.el .nr Hm .5i
+.nr Fm .5i
+.nr ll 78n
+.ll 78n
+.nr lt 78n
+.lt 78n
+.nr po 0i
+.po 0i
+.nr dV 1v
+.ad l
+.na
+..
+.ds <= \&<\&=
+.ds >= \&>\&=
+.ds Rq ''
+.ds Lq ``
+.ds ua ^
+.ds aa \'
+.ds ga \`
+.ds sL `
+.ds sR '
+.ds q \&"
+.ds Pi pi
+.ds Ne !=
+.ds Le <=
+.ds Ge >=
+.ds Lt <
+.ds Gt >
+.ds Pm +-
+.ds If infinity
+.ds Na \fINaN\fP
+.ds Ba \fR\&|\fP
+
+.de hK
+.nr % 1
+.ds hT \\*(dT
+.if !"\\*(cH"Null" \{\
+.	ie !"\\*(gP"Null" .as hT \|(\|\\*(cH\\*(gP\|)
+.	el .as hT \\|(\\|\\*(cH\\|)
+.\}
+.if "\\*(cH"Null" .if !"\\*(gP"Null" .as hT \&\|(\|\\*(gP\|)
+.ie \\n(cR \{\
+.	hM
+.	wh -1v fM
+.\}
+.el \{\
+.	wh 0 hM
+.	wh -1.167i fM
+.\}
+.if \\n(nl==0:\\n(nl==-1 'bp
+.em lM
+..
+.nr fW \w'0'
+.de sW
+.nr sW \w\\$1
+.ie \\n(sW>=\\n(fW \{\
+.       ie \\n(sW%\\n(fW .nr sW (\\n(sW/\\n(fW)+1
+.       el .nr sW \\n(sW/\\n(fW
+.\}
+.el .nr sW 0
+..
+.de aW
+.nr sW \w\\*(A\\$1
+.ie \\n(sW>=\\n(fW \{\
+.       ie \\n(sW%\\n(fW .nr sW (\\n(sW/\\n(fW)+1
+.       el .nr sW \\n(sW/\\n(fW
+.\}
+.el .nr sW 0
+..
+.de Ql
+.if \\n(aC==0  \{\
+.	ds mN Ql
+.	ds A1 \\$1
+.	ds A2 \\$2
+.	ds A3 \\$3
+.	ds A4 \\$4
+.	ds A5 \\$5
+.	ds A6 \\$6
+.	ds A7 \\$7
+.	ds A8 \\$8
+.	ds A9 \\$9
+.	nr fV \\n(.$
+. 	fV
+.\}
+.ds qL \&\\*(sL
+.ds qR \&\\*(sR
+.En \\$1 \\$2 \\$3 \\$4 \\$5 \\$6 \\$7 \\$8 \\$9
+..
+.de Sh
+.nr nS 0
+.nr sE 0
+.nr iS 0
+.ie "\\$1"NAME" \{\
+.       hK
+'       in 0
+.\}
+.el \{\
+.	ie "\\$1"Ì¾Á°" \{\
+.      		hK
+'       	in 0
+.	\}
+.	el \{\
+.		ie "\\$1"Ì¾¾Î" \{\
+.       		hK
+'       		in 0
+.		\}
+.		el \{\
+.       		nr nS 0
+.       		nr nA 0
+.       		nr nF 0
+.       		nr nT 0
+.       		nr nY 0
+.       		nr aN 0
+.       		nr oT 0
+.       		if "\\$1"SEE" .nr nA 1
+.       		if "\\$1"´ØÏ¢¹àÌÜ" .nr nA 1
+.       		if "\\$1"FILES" .nr nF 1
+.       		if "\\$1"¥Õ¥¡¥¤¥ë" .nr nF 1
+.       		if "\\$1"´ØÏ¢¥Õ¥¡¥¤¥ë" .nr nF 1
+.       		if "\\$1"STANDARDS" .nr nT 1
+.       		if "\\$1"½àµò" .nr nT 1
+.       		if "\\$1"µ¬³Ê" .nr nT 1
+.       		if "\\$1"SYNOPSIS" .nr nS 1
+.       		if "\\$1"½ñ¼°" .nr nS 1
+.       		if "\\$1"DESCRIPTION" \{\
+.               		rr fB
+.               		rr Fb
+.               		ds Fb
+.               		nr fY 0
+.               		nr fZ 0
+.      			\}
+.       		if "\\$1"ÀâÌÀ" \{\
+.               		rr fB
+.               		rr Fb
+.               		ds Fb
+.               		nr fY 0
+.               		nr fZ 0
+.      			 \}
+.       		if "\\$1"²òÀâ" \{\
+.               		rr fB
+.               		rr Fb
+.               		ds Fb
+.               		nr fY 0
+.               		nr fZ 0
+.       		\}
+.			if "\\$1"AUTHORS" .nr nY 1
+.			if "\\$1"Ãø¼Ô" .nr nY 1
+.			if "\\$1"ºî¼Ô" .nr nY 1
+.     			in 0
+.		\}
+.	\}
+.\}
+.pL
+'sp
+.ns
+.ta .5i 1i 1.5i 2i 2.5i 3i 3.5i 4i 4.5i 5i 5.5i 6i 6.5i
+.if !\\n(cR .ne 3
+'fi
+\&\\*(sH\\$1 \|\\$2 \|\\$3 \|\\$4 \|\\$5 \|\\$6 \|\\$7 \|\\$8 \|\\$9
+\&\fP\s0\&
+.in \\n(.iu+\\n(Tiu
+.if "\\$1"SEE" .nr sE 1
+.ns
+..
